gtkmm: Gtk::ColorDialog Class Reference

gtkmm 4.16.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::ColorDialog Class Reference
Dialogs

A Gtk::ColorDialog object collects the arguments that are needed to present a color chooser dialog to the user, such as a title for the dialog and whether it should be modal. More...

`#include <gtkmm/colordialog.h>`

Inheritance diagram for Gtk::ColorDialog:
[legend]

## Public Member Functions
| ColorDialog (ColorDialog && src) noexcept
ColorDialog & | operator= (ColorDialog && src) noexcept
| ~ColorDialog () noexcept override
GtkColorDialog * | gobj ()
| Provides access to the underlying C GObject.
const GtkColorDialog * | gobj () const
| Provides access to the underlying C GObject.
GtkColorDialog * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ustring | get_title () const
| Returns the title that will be shown on the color chooser dialog.
void | set_title (const Glib::ustring & title)
| Sets the title that will be shown on the color chooser dialog.
bool | get_modal () const
| Returns whether the color chooser dialog blocks interaction with the parent window while it is presented.
void | set_modal (bool modal=true)
| Sets whether the color chooser dialog blocks interaction with the parent window while it is presented.
bool | get_with_alpha () const
| Returns whether colors may have alpha.
void | set_with_alpha (bool with_alpha=true)
| Sets whether colors may have alpha.
void | choose_rgba (Window & parent, const Gdk::RGBA & initial_color, const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| This function initiates a color choice operation by presenting a color chooser dialog to the user.
void | choose_rgba (Window & parent, const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| A choose_rgba() convenience overload.
void | choose_rgba (const Gdk::RGBA & initial_color, const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| A choose_rgba() convenience overload.
void | choose_rgba (const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| A choose_rgba() convenience overload.
Gdk::RGBA | choose_rgba_finish (const Glib::RefPtr< Gio::AsyncResult > & result) const
| Finishes the choose_rgba() call and returns the resulting color.
Glib::PropertyProxy< Glib::ustring > | property_title ()
| A title that may be shown on the color chooser dialog that is presented by Gtk::ColorDialog::choose_rgba().
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_title () const
| A title that may be shown on the color chooser dialog that is presented by Gtk::ColorDialog::choose_rgba().
Glib::PropertyProxy< bool > | property_modal ()
| Whether the color chooser dialog is modal.
Glib::PropertyProxy_ReadOnly< bool > | property_modal () const
| Whether the color chooser dialog is modal.
Glib::PropertyProxy< bool > | property_with_alpha ()
| Whether colors may have alpha (translucency).
Glib::PropertyProxy_ReadOnly< bool > | property_with_alpha () const
| Whether colors may have alpha (translucency).
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< ColorDialog > | create ()

## Protected Member Functions
| ColorDialog ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::ColorDialog > | wrap (GtkColorDialog * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data) | DestroyNotify

## Detailed Description

A Gtk::ColorDialog object collects the arguments that are needed to present a color chooser dialog to the user, such as a title for the dialog and whether it should be modal.

The dialog is shown with the choose_rgba() method. This API follows the GIO async pattern, and the result can be obtained by calling choose_rgba_finish().

See Gtk::ColorDialogButton for a convenient control that uses Gtk::ColorDialog and presents the results.

Since gtkmm 4.10

## Constructor & Destructor Documentation

## ◆ ColorDialog() [1/2]

Gtk::ColorDialog::ColorDialog | ( | ColorDialog && | src | ) |
| noexcept

## ◆ ~ColorDialog()

Gtk::ColorDialog::~ColorDialog | ( |  | ) |
| overridenoexcept

## ◆ ColorDialog() [2/2]

Gtk::ColorDialog::ColorDialog | ( |  | ) |
| protected

## Member Function Documentation

## ◆ choose_rgba() [1/4]

void Gtk::ColorDialog::choose_rgba | ( | const Gdk::RGBA & | initial_color,
|  | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = {} ) const

A choose_rgba() convenience overload.

## ◆ choose_rgba() [2/4]

void Gtk::ColorDialog::choose_rgba | ( | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = {} ) const

A choose_rgba() convenience overload.

## ◆ choose_rgba() [3/4]

void Gtk::ColorDialog::choose_rgba | ( | Window & | parent,
|  | const Gdk::RGBA & | initial_color,
|  | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = {} ) const

This function initiates a color choice operation by presenting a color chooser dialog to the user.

Since gtkmm 4.10

Parameters

  parent | The parent `Gtk::Window`.
  initial_color | The color to select initially.
  cancellable | A `Cancellable` to cancel the operation.
  slot | A callback to call when the operation is complete.

## ◆ choose_rgba() [4/4]

void Gtk::ColorDialog::choose_rgba | ( | Window & | parent,
|  | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = {} ) const

A choose_rgba() convenience overload.

## ◆ choose_rgba_finish()

Gdk::RGBA Gtk::ColorDialog::choose_rgba_finish | ( | const Glib::RefPtr< Gio::AsyncResult > & | result | ) | const

Finishes the choose_rgba() call and returns the resulting color.

Since gtkmm 4.10

Parameters

  result | A `Gio::AsyncResult`.

Returns
  The selected color, or `nullptr` and error is set.

Exceptions

  Gtk::DialogError |

## ◆ create()

static Glib::RefPtr< ColorDialog > Gtk::ColorDialog::create | ( |  | ) |
| static

## ◆ get_modal()

bool Gtk::ColorDialog::get_modal | ( |  | ) | const

Returns whether the color chooser dialog blocks interaction with the parent window while it is presented.

Since gtkmm 4.10

Returns
  `true` if the color chooser dialog is modal.

## ◆ get_title()

Glib::ustring Gtk::ColorDialog::get_title | ( |  | ) | const

Returns the title that will be shown on the color chooser dialog.

Since gtkmm 4.10

Returns
  The title.

## ◆ get_type()

static GType Gtk::ColorDialog::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_with_alpha()

bool Gtk::ColorDialog::get_with_alpha | ( |  | ) | const

Returns whether colors may have alpha.

Since gtkmm 4.10

Returns
  `true` if colors may have alpha.

## ◆ gobj() [1/2]

GtkColorDialog * Gtk::ColorDialog::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkColorDialog * Gtk::ColorDialog::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkColorDialog * Gtk::ColorDialog::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

ColorDialog & Gtk::ColorDialog::operator= | ( | ColorDialog && | src | ) |
| noexcept

## ◆ property_modal() [1/2]

Glib::PropertyProxy< bool > Gtk::ColorDialog::property_modal | ( |  | ) |

Whether the color chooser dialog is modal.

Since gtkmm 4.10

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_modal() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ColorDialog::property_modal | ( |  | ) | const

Whether the color chooser dialog is modal.

Since gtkmm 4.10

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_title() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::ColorDialog::property_title | ( |  | ) |

A title that may be shown on the color chooser dialog that is presented by Gtk::ColorDialog::choose_rgba().

Since gtkmm 4.10

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_title() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::ColorDialog::property_title | ( |  | ) | const

A title that may be shown on the color chooser dialog that is presented by Gtk::ColorDialog::choose_rgba().

Since gtkmm 4.10

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_with_alpha() [1/2]

Glib::PropertyProxy< bool > Gtk::ColorDialog::property_with_alpha | ( |  | ) |

Whether colors may have alpha (translucency).

When with-alpha is `false`, the color that is selected will be forced to have alpha == 1.

Since gtkmm 4.10

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_with_alpha() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ColorDialog::property_with_alpha | ( |  | ) | const

Whether colors may have alpha (translucency).

When with-alpha is `false`, the color that is selected will be forced to have alpha == 1.

Since gtkmm 4.10

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_modal()

void Gtk::ColorDialog::set_modal | ( | bool | modal = true | ) |

Sets whether the color chooser dialog blocks interaction with the parent window while it is presented.

Since gtkmm 4.10

Parameters

  modal | The new value.

## ◆ set_title()

void Gtk::ColorDialog::set_title | ( | const Glib::ustring & | title | ) |

Sets the title that will be shown on the color chooser dialog.

Since gtkmm 4.10

Parameters

  title | The new title.

## ◆ set_with_alpha()

void Gtk::ColorDialog::set_with_alpha | ( | bool | with_alpha = true | ) |

Sets whether colors may have alpha.

Since gtkmm 4.10

Parameters

  with_alpha | The new value.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::ColorDialog > wrap | ( | GtkColorDialog * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.